
#define IN_LIBXML
#include "../src/libxml.h"
#include "xmlbase.h"
#include "wrapper.h"

CXMLWrapper xml;

EXMLPUBFUN xnode EXMLCALL xmlLoadMemory(const char *buffer, int size)
{
    return xml.LoadXML(buffer, size);
}

EXMLPUBFUN xnode EXMLCALL xmlLoadMemoryToNode(xnode node, const char *buffer, int size)
{
    return xml.LoadXMLToNode(node, buffer, size);
}

EXMLPUBFUN xnode EXMLCALL xmlLoad(const char *filename)
{
	return xml.LoadXMLFile(filename);
}

EXMLPUBFUN xnode EXMLCALL xmlLoadToNode(xnode node, const char *filename)
{
	return xml.LoadXMLFileToNode(node, filename);
}

EXMLPUBFUN xlist EXMLCALL xmlRequest(xnode node, const char *request)
{
    return xml.Request(node, request);
}

EXMLPUBFUN xlist EXMLCALL xmlRootRequest(const char *request)
{
	return xml.Request(0, request);
}

EXMLPUBFUN void EXMLCALL xmlDestroy()
{
	xml.Destroy();
}

EXMLPUBFUN xstring EXMLCALL xmlGetName(xnode node)
{
	return xml.GetName(node);
}

EXMLPUBFUN xstring EXMLCALL xmlGetAttribute(xnode node, const char *atname)
{
	return xml.GetAttribute(node, atname);
}

EXMLPUBFUN xstring EXMLCALL xmlGetText(xnode node)
{
	return xml.GetText(node);
}

EXMLPUBFUN xstring EXMLCALL xmlGetCDataText(xnode node)
{
    return xml.GetCDataText(node);
}

EXMLPUBFUN int EXMLCALL xmlGetListSize(xlist nodelist)
{
	return xml.GetListSize(nodelist);
}

EXMLPUBFUN void EXMLCALL xmlFreeList(xlist nodelist)
{
	return xml.ReleaseList(nodelist);
}

EXMLPUBFUN int EXMLCALL xmlSave(xnode node, const char *filename)
{
	return xml.SaveXMLFile(node, filename);
}

EXMLPUBFUN xnode EXMLCALL xmlCreateRootNode(const char* nodename)
{
	return xml.CreateNode(0, nodename);
}

EXMLPUBFUN xnode EXMLCALL xmlCreateNode(xnode parentnode, const char* nodename)
{
	return xml.CreateNode(parentnode, nodename);
}

EXMLPUBFUN void EXMLCALL xmlDeleteNode(xnode node)
{
	xml.DeleteNode(node);
}

EXMLPUBFUN int EXMLCALL xmlSetAttribute(xnode node, const char *atname, const char *value)
{
	return xml.SetAttribute(node, atname, value);
}

EXMLPUBFUN int EXMLCALL xmlSetText(xnode node, const char *text)
{
	return xml.SetText(node, text);
}

EXMLPUBFUN xnode EXMLCALL xmlMakeNodeCopy(xnode node, xnode parent_node)
{
    return xml.MakeNodeCopy(node, parent_node);
}
