
#ifndef __XML_H__
#define __XML_H__ 

#include "exports.h"
#include <libxml/parser.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef xmlNodePtr xnode;
typedef xmlNodePtr* xlist;
typedef const unsigned char* xstring; 

EXMLPUBFUN xnode EXMLCALL xmlLoadMemory(const char *buffer, int size);  //   
EXMLPUBFUN xnode EXMLCALL xmlLoadMemoryToNode(xnode node, const char *buffer, int size);  

EXMLPUBFUN xnode EXMLCALL xmlLoad(const char *filename);                //    
EXMLPUBFUN xnode EXMLCALL xmlLoadToNode(xnode node, const char *filename);
EXMLPUBFUN void  EXMLCALL xmlDestroy();                                 //  xml   

EXMLPUBFUN xlist EXMLCALL xmlRootRequest(const char *request);          //  XPath  
EXMLPUBFUN xlist EXMLCALL xmlRequest(xnode node, const char *request);  //  XPath
EXMLPUBFUN int   EXMLCALL xmlGetListSize(xlist nodelist);               //    
EXMLPUBFUN void  EXMLCALL xmlFreeList(xlist nodelist);                  //   

EXMLPUBFUN xstring EXMLCALL xmlGetName(xnode node);                     //    
EXMLPUBFUN xstring EXMLCALL xmlGetAttribute(xnode node, const char *atname); //   
EXMLPUBFUN xstring EXMLCALL xmlGetText(xnode node);                     //      
EXMLPUBFUN xstring EXMLCALL xmlGetCDataText(xnode node);

EXMLPUBFUN int EXMLCALL xmlSave(xnode node, const char *filename);

EXMLPUBFUN xnode EXMLCALL xmlCreateNode(xnode parentnode, const char* nodename);
EXMLPUBFUN xnode EXMLCALL xmlCreateRootNode(const char* nodename); 
EXMLPUBFUN void  EXMLCALL xmlDeleteNode(xnode node);
EXMLPUBFUN int   EXMLCALL xmlSetAttribute(xnode node, const char *atname, const char *value);
EXMLPUBFUN int   EXMLCALL xmlSetText(xnode node, const char *text);

EXMLPUBFUN xnode EXMLCALL xmlMakeNodeCopy(xnode node, xnode parent_node);

#ifdef __cplusplus
}

#endif /* __cplusplus */ 
#endif // __XML_H__
