#include "stdafx.h"
#include "luaSupport.h"

#ifdef _DEBUG
#pragma comment(lib,"luad.lib")
#else
#pragma comment(lib,"lua.lib")
#endif

luaT_script::luaT_script(lua_State* pL) : L(pL)
{
    assert(L);
}

luaT_script::~luaT_script()
{
}

bool luaT_script::run(const tstring& script, tstring* error)
{
    WideToUtf8 w2u(script.c_str());
    luaL_loadstring(L, w2u);
    if (!lua_pcall(L, 0, 0, 0))
        return true;

    if (error)
    {
        Utf8ToWide u2w(lua_tostring(L, -1));
        error->assign(u2w);
    }
    lua_pop(L, 1);
    return false;
}
