#pragma once

#include "propertiesPages/propertiesData.h"
#include "mudViewParser.h"
#include "incomingObjects.h"

class IncomingProcessor
{
public:
    IncomingProcessor(PropertiesData *pdata);
    ~IncomingProcessor();
    void updateProps();
    void processActions(parseData *parse_data, std::vector<tstring>* new_cmds);
    void processSubs(parseData *parse_data);
    void processHighlights(parseData *parse_data);   

private:
    void initActions();
    void clearActions();
    void initSubs();
    void clearSubs();
    void initHighlights();
    void clearHighlights();
    
    PropertiesData *pData;
    std::vector<Action*> m_actions;
    std::vector<Sub*> m_subs;
    std::vector<Highlight*> m_highlights;
};
