#pragma once

#include "propertiesPages/propertiesData.h"

class InputCommand
{
public:
    InputCommand(tstring cmd);
    tstring full_command;                   // full command (with parameters)
    tstring command;                        // only command
    tstring parameters;                     // only parameters (without command) as single line (without trimming)
    std::vector<tstring> parameters_list;   // list of parameters separately
};

typedef std::vector<InputCommand*> InputCommandsList;

class InputProcessor
{   
public:
    InputProcessor(PropertiesData *pdata);
    ~InputProcessor();
    void process(const tstring& cmd);
    InputCommandsList commands;

private:   
    void processSeparators(const tstring& sep_cmd, InputCommandsList* result);
    bool processAliases(InputCommand* cmd, tstring* result);
    void processParameters(const tstring& cmd, InputCommand* params, tstring* result);
    PropertiesData *pData;
};
