#include "stdafx.h"
#include "mudGameView.h"

void MudGameView::siLog(const tstring& cmd)
{
    tstring log(L"\r\n[jmc] ");
    log.append(cmd);
    log.append(L"\r\n");
    processIncoming(log.c_str(), log.length());
}

void MudGameView::siError(const tstring& cmd, const tstring& error)
{
    tstring msg(L": ");    
    msg.append(error);
    msg.append(L" (");
    msg.append(cmd);
    msg.append(L")");
    siLog(msg);
}

void MudGameView::siConnect(const tstring& address, int port)
{
    if (m_connected)
    {
        siLog(L"  !      .");
        return;
    }

    siLog(L"...");
    NetworkConnectData data;
    data.address = W2AN(address);
    data.port = port;
    data.notifyMsg = WM_USER+1;
    data.wndToNotify = m_hWnd;
    if (m_network.connect(data))
    {
        m_connected = true;
        return;
    }
    
    siLog(L":   .");
}

void MudGameView::siLostConnection()
{
    siLog(L" ().");
    m_connected = false; 
}
