#pragma once

struct MudViewStringParams
{
    MudViewStringParams() { reset(); }
    void reset() 
    {
        text_color = 7;
        bkg_color = 0;
        intensive_status = 0;
        underline_status = 0;
        italic_status = 0;
        blink_status = 0;
        reverse_video = 0;
        use_ext_colors = 0;
        ext_text_color = 0;
        ext_bkg_color = 0;
    }

    bool operator==(const MudViewStringParams& p)
    {
        if (text_color == p.text_color &&
            bkg_color == p.bkg_color &&
            intensive_status == p.intensive_status &&
            underline_status == p.underline_status &&
            italic_status == p.italic_status &&
            blink_status == p.blink_status &&
            reverse_video == p.reverse_video &&
            use_ext_colors == p.use_ext_colors
            )
        {
            if (!use_ext_colors)
                return true;
            if (ext_text_color == p.ext_text_color &&
                ext_bkg_color == p.ext_bkg_color)
                return true;            
        }
        return false;
    }

    tbyte text_color;              // support 256 colors (0-15 - from palette)
    tbyte bkg_color;               // 256 colors
    tbyte intensive_status;
    tbyte underline_status;
    tbyte italic_status;
    tbyte blink_status;
    tbyte reverse_video;
    tbyte use_ext_colors;          // flag for use extended colors
    COLORREF ext_text_color;       // extended colors (for highlights)
    COLORREF ext_bkg_color;
};

struct MudViewStringBlock
{
   MudViewStringBlock() { size.cx = 0; size.cy = 0; }
   tstring string;                        // text string
   MudViewStringParams params;            // string params
   SIZE size;                             // size of string (DC size of current font)
};

struct MudViewString
{
   void moveBlocks(MudViewString* s) 
   {
       for (int i=0,e=s->blocks.size(); i<e; ++i)
           blocks.push_back(s->blocks[i]);
       s->blocks.clear();
   }
   std::vector<MudViewStringBlock> blocks;  // all string blocks    
};
