#pragma once

struct NetworkConnectData
{    
    std::string address;
    int port;
    HWND wndToNotify;
    UINT notifyMsg;
};

enum NetworkEvents
{
    NE_NOEVENT = 0,
    NE_NEWDATA,    
    NE_DISCONNECT,
    NE_ERROR
};

class Network
{
public:
    Network();
    ~Network();
    bool connect(const NetworkConnectData& data);
    NetworkEvents processMsg(DWORD msg_lparam);
    DataQueue* receive();
    int send(const tbyte* data, int len);    

private:
    bool send_ex(const tbyte* data, int len);
    int read_socket();
    int write_socket();
    void close();
    int processing_data(const tbyte* buffer, int len, bool *error);
    void turnon_mccp();

    MemoryBuffer m_input_buffer;            // to receive data from network
    DataQueue m_input_data;                 // accamulated data from network
    DataQueue m_receive_data;               // ready to receive by app
    DataQueue m_output_buffer;              // buffer to compile output data
    DataQueue m_send_data;                  // data for send to server

    bool m_can_send;
    SOCKET sock;
};
