#pragma once
#include "PropertiesData.h"

class PropertiesManager
{
public:
    PropertiesManager();
    ~PropertiesManager();

    bool init();  
    bool loadProfile();
    bool saveProfile();    
    PropertiesData* getConfig() { return &m_propData; }
    const tstring& getProfileGroup() { return m_configName; }
    const tstring& getProfileName() { return m_profileName; }

    bool createNewProfile(const tstring& name);
    bool createCopyProfile(const tstring& from, const tstring& name);
    bool loadNewProfile(const tstring& group, const tstring& name);
    bool createNewProfile(const tstring& group, const tstring& name);

private:
    bool loadSettings();
    bool loadHistory();
    bool loadProfileData();

    bool saveProfileData();
    bool saveHistory();
    bool saveSettings();    

    typedef PropertiesType<tstring, tstring> props_array;
    bool loadRgbColor(xml::node n, std::string* name, COLORREF* color);
    void loadArray(xml::node n, const std::string& name, props_array* value);
    void saveRgbColor(xml::node parent, const std::string& name, COLORREF color);    
    void saveArray(xml::node parent, const std::string& name, const props_array& value);
    bool loadFromFile(xml::node& node, const tstring& file);
    bool saveToFile(xml::node node, const tstring& file);
  
private:
    tstring m_configName;
    tstring m_profileName;
    PropertiesData m_propData;
};
