#pragma once

class PropertyCommon :  public CDialogImpl<PropertyCommon>
{
    PropertiesData *propData;
    CBevelLine m_bl1;
    CBevelLine m_bl2;
    CEdit m_history_size;
    CEdit m_cmd_size;

public:
    enum { IDD = IDD_PROPERTY_COMMON };
    PropertyCommon(PropertiesData *data) : propData(data) {}

private:
    BEGIN_MSG_MAP(PropertyCommon)
       MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
       COMMAND_HANDLER(IDC_EDIT_VIEW_HISTORY, EN_KILLFOCUS, OnViewHistory)
       COMMAND_HANDLER(IDC_EDIT_CMD_HISTORY, EN_KILLFOCUS, OnCmdHistory)
    END_MSG_MAP()

    LRESULT OnInitDialog(UINT, WPARAM, LPARAM, BOOL&)
	{
        m_bl1.SubclassWindow(GetDlgItem(IDC_STATIC_COMMON_BL1));
        m_bl2.SubclassWindow(GetDlgItem(IDC_STATIC_COMMON_BL2));
        m_history_size.Attach(GetDlgItem(IDC_EDIT_VIEW_HISTORY));
        m_history_size.SetLimitText(3);
        m_cmd_size.Attach(GetDlgItem(IDC_EDIT_CMD_HISTORY));
        m_cmd_size.SetLimitText(2);
    
        wchar_t buffer[8];
        _itow(propData->view_history_size, buffer, 10);
        m_history_size.SetWindowText(buffer);
        _itow(propData->cmd_history_size, buffer, 10);
        m_cmd_size.SetWindowText(buffer);
        return 0;
    }

    LRESULT OnViewHistory(WORD, WORD, HWND, BOOL&)  
    {
        tstring count_text;
        getWindowText(m_history_size, &count_text);
        int count = _wtoi(count_text.c_str());
        if (count < MIN_VIEW_HISTORY_SIZE || count > MAX_VIEW_HISTORY_SIZE)
        {
            if (count < MIN_VIEW_HISTORY_SIZE)
                count = MIN_VIEW_HISTORY_SIZE;
            else
                count = MAX_VIEW_HISTORY_SIZE;            
            wchar_t buffer[8];
            _itow(count, buffer, 10);
            m_history_size.SetWindowText(buffer);
        }
        propData->view_history_size = count;
        return 0;
    }

    LRESULT OnCmdHistory(WORD, WORD, HWND, BOOL&)   
    {
        tstring count_text;
        getWindowText(m_cmd_size, &count_text);
        int count = _wtoi(count_text.c_str());
        if (count < MIN_CMD_HISTORY_SIZE || count > MAX_CMD_HISTORY_SIZE)
        {
            if (count < MIN_CMD_HISTORY_SIZE)
                count = MIN_CMD_HISTORY_SIZE;
            else
                count = MAX_CMD_HISTORY_SIZE;            
            wchar_t buffer[8];
            _itow(count, buffer, 10);
            m_cmd_size.SetWindowText(buffer);
        }
        propData->cmd_history_size = count;
        return 0;
    }
};
