#include "stdafx.h"
#include "systemInterpretator.h"
#include "InputProcessor.h"

SystemInterpretator::SystemInterpretator() {}
SystemInterpretator::~SystemInterpretator() {}

SystemInterpretatorCallback* callback(lua_State* L) {
    return (SystemInterpretatorCallback*)lua_getextra(L);
}

void SystemInterpretator::process(const tstring& cmd)
{
    //translate #cmd par1, par2, par3 -> cmd("par1","par2","par3") and run in LUA context
    InputCommand ic(cmd);

    tstring lua_cmd(ic.command.substr(1));  
    lua_cmd.append(L"(");
    for (int i=0,e=ic.parameters_list.size()-1; i<=e; ++i)
    {
        lua_cmd.append(L"\"");
        lua_cmd.append(ic.parameters_list[i]);
        lua_cmd.append(L"\"");
        if (i != e)
            lua_cmd.append(L",");
    }
    lua_cmd.append(L")");

    tstring error;
    luaT_script script(L);
    if (!script.run(lua_cmd, &error)) {
        callback(L)->siError(cmd, error);        
    }
}
//------------------------------------------------------------------------------------
enum SystemInterpretatorErrors {
    SI_INCORRECT_PARAMETERS = 0

};

int error(lua_State*L, int type)
{
    tstring error;
    switch (type)
    {
    case SI_INCORRECT_PARAMETERS:
        error = L"  ";
    break;
    }

    lua_pushstring(L,  W2U(error));
    return lua_error(L); 
}

int connect(lua_State *L)
{
    int n = lua_gettop(L);
    if (n = 2 && lua_isnumber(L, -1) && lua_isstring(L, -2))
    {   
        callback(L)->siConnect( U2W(lua_tostring(L, -2)), lua_tointeger(L, -1));
        return 0;
    }    
    return error(L, SI_INCORRECT_PARAMETERS);    
}

bool SystemInterpretator::init(SystemInterpretatorCallback* callback)
{   
    lua_setextra(L, callback);
    lua_register(L, "connect", connect);

    return true;
}
