
#ifndef __WRAPPER_H__
#define __WRAPPER_H__ 

#include <map>
#include <list>
#include <set>
#include "xmlbase.h"

typedef unsigned int uint;

class CXMLWrapper
{
public:
	CXMLWrapper();
	~CXMLWrapper();

    xnode LoadXML(const char *buffer, int size);  //   
    xnode LoadXMLToNode(xnode node, const char *buffer, int size);  

	xnode LoadXMLFile(const char *filename);
	xnode LoadXMLFileToNode(xnode node, const char *filename);
	void  Destroy();                                     //    	

    xlist Request(xnode node, const char *request);
		
	int   GetListSize(xlist nodelist); 
	void  ReleaseList(xlist nodelist);	
	
	xstring GetName(xnode node);                             //    
	xstring GetAttribute(xnode node, const char *atname);    //   
	xstring GetText(xnode node);  
	xstring GetCDataText(xnode node);

	int   SaveXMLFile(xnode node, const char *filename);
	
	xnode CreateNode(xnode parentnode, const char* nodename);
	void  DeleteNode(xnode node);
	int   SetAttribute(xnode node, const char *atname, const char *value);

	int   SetText(xnode node, const char *text);

    xnode MakeNodeCopy(xnode node, xnode parent_node);

private:
	xmlDocPtr  rootdoc;
	xmlNodePtr rootnode;
    		
    void FormatTree(xmlNodePtr root);
    
};

#endif // __WRAPPER_H__
