
#ifndef __LIBXM_H__
#define __LIBXM_H__ 

#ifdef __cplusplus
extern "C" {
#endif

typedef void* xnode;
typedef void** xlist;
typedef const char* xstring;

xnode xmlLoadMemory(const char *buffer, int size);                          //   
xnode xmlLoadMemoryToNode(xnode node, const char *buffer, int size);  

xnode xmlLoad(const char *filename);                                      //    
xnode xmlLoadToNode(xnode node, const char *filename);                    //    
void  xmlDestroy();                                                       //  xml   

xlist xmlRootRequest(const char *request);                                //  XPath  
xlist xmlRequest(xnode node, const char *request);                        //  XPath
int   xmlGetListSize(xlist nodelist);                                     //    
void  xmlFreeList(xlist nodelist);                                        //   

xstring xmlGetName(xnode node);                                           //    
xstring xmlGetAttribute(xnode node, const char *atname);                  //   
xstring xmlGetText(xnode node);                                           //   .   
xstring xmlGetCDataText(xnode node);                                      //    CDATA  

int   xmlSave(xnode node, const char *filename);                          //   xml  
xnode xmlCreateRootNode(const char* nodename);                            //    
xnode xmlCreateNode(xnode parentnode, const char* nodename);              //     
void  xmlDeleteNode(xnode node);                                          //   (  )
int   xmlSetAttribute(xnode node, const char *atname, const char *value); // ()   
int   xmlSetText(xnode node, const char *text);                           //    

xnode xmlMakeNodeCopy(xnode node, xnode parent_node);                     //  ,   ,   

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif // __LIBXM_H__
