#include "stdafx.h"
#include "common.h"

void loadString(UINT id, tstring* string)
{
    WCHAR buffer[256];
    LoadString(GetModuleHandle(NULL), id, buffer, 256);
    string->assign(buffer);
}

int msgBox(HWND parent, UINT msg, UINT options)
{
    tstring msg_text, title_text;
    loadString(msg, &msg_text);
    loadString(IDR_MAINFRAME, &title_text);
    return MessageBox(parent, msg_text.c_str(), title_text.c_str(), options);
}

void getWindowText(HWND handle, tstring *string)
{
    int text_len = ::GetWindowTextLength(handle);
    MemoryBuffer tmp((text_len+2)*sizeof(WCHAR)); 
    WCHAR *buffer = (WCHAR*)tmp.getData();
    ::GetWindowText(handle, buffer, text_len+1);
    string->assign(buffer);
}

bool isOnlySymbolsA(const std::string& str, const std::string& symbols)
{
   int pos = strspn(str.c_str(), symbols.c_str());
   return (pos != str.length()) ? false : true;
}

bool isOnlyDigitsA(const std::string& str)
{
    return isOnlySymbolsA(str, "0123456789");
}

bool a2int(const std::string& str, int *value)
{
    if (!isOnlyDigitsA(str))
        return false;
    *value = atoi(str.c_str());
    return true;
}

bool isExistSymbols(const tstring& str, const tstring& symbols)
{
   int pos = wcscspn(str.c_str(), symbols.c_str());
   return (pos != str.length()) ? true : false;
}


void tstring_trimleft(tstring *str)
{
    int pos = wcsspn(str->c_str(), L" ");
    if (pos != 0)
        str->assign(str->substr(pos));
}

void tstring_trimright(tstring *str)
{
    if (str->empty())
        return;
    int last = str->size() - 1;
    int pos = last;
    while (str->at(pos) == L' ')
        pos--;
    if (pos != last)
        str->assign(str->substr(0, pos+1));
}

void tstring_trim(tstring *str)
{
    tstring_trimleft(str);
    tstring_trimright(str);
}
