#include "stdafx.h"
#include "incomingProcessor.h"

void IncomingProcessor::processActions(parseData *parse_data, std::vector<tstring>* new_cmds)
{
    for (int j=0,je=parse_data->strings.size(); j<je; ++j)
    {
        MudViewString *s = parse_data->strings[j];
        for (int k=0,ke=s->blocks.size(); k<ke; ++k)
        {
            for (int i=0,e=m_actions.size(); i<e; ++i)
            {
                tstring newcmd;
                if (m_actions[i]->processing(&s->blocks[k], &newcmd))
                {
                    new_cmds->push_back(newcmd);
                    break;
                }
            }
        }
    }
}

void IncomingProcessor::processSubs(parseData *parse_data)
{
    for (int j=0,je=parse_data->strings.size(); j<je; ++j)
    {
        MudViewString *s = parse_data->strings[j];
        for (int k=0,ke=s->blocks.size(); k<ke; ++k)
        {
            for (int i=0,e=m_subs.size(); i<e; ++i)
            {
                if (m_subs[i]->processing(&s->blocks[k]))
                {
                    i = 0;  // restart subs
                }
            }
        }
    }    
}

void IncomingProcessor::processHighlights(parseData *parse_data)
{
    for (int j=0,je=parse_data->strings.size(); j<je; ++j)
    {
        MudViewString *s = parse_data->strings[j];
        for (int i=0,e=m_highlights.size(); i<e; ++i)
        {
            m_highlights[i]->processing(s);
        }        
    }
}
//---------------------------------------------------------------------------
IncomingProcessor::IncomingProcessor(PropertiesData *pdata) : pData(pdata)
{
}

IncomingProcessor::~IncomingProcessor()
{
    clearActions();
    clearSubs();
    clearHighlights();
}

void IncomingProcessor::updateProps()
{
    initActions();
    initSubs();
    initHighlights();
}

void IncomingProcessor::initActions()
{
    clearActions();
    int actions = pData->actions.size();
    for (int i=0; i<actions; ++i)
    {
        const PropertiesData::action_data &a = pData->actions.get(i);
        Action *action = new Action(a.key, a.value);
        m_actions.push_back(action);        
    }
}

void IncomingProcessor::clearActions()
{
    struct{ void operator() (Action* cmd) { delete cmd; }} autodel;
    std::for_each(m_actions.begin(), m_actions.end(), autodel);
    m_actions.clear();
}

void IncomingProcessor::initSubs()
{
    clearSubs();
    int substs = pData->subs.size();
    for (int i=0; i<substs; ++i)
    {
        const PropertiesData::sub_data &a = pData->subs.get(i);
        Sub *s = new Sub(a.key, a.value);
        m_subs.push_back(s);        
    }
}

void IncomingProcessor::clearSubs()
{
    struct{ void operator() (Sub* cmd) { delete cmd; }} autodel;
    std::for_each(m_subs.begin(), m_subs.end(), autodel);
    m_subs.clear();
}

void IncomingProcessor::initHighlights()
{
    clearHighlights();
    int hl = pData->highlights.size();
    for (int i=0; i<hl; ++i)
    {
        const PropertiesData::highlight_data &a = pData->highlights.get(i);
        Highlight *h = new Highlight(a.key, a.value);
        m_highlights.push_back(h);
    }
}

void IncomingProcessor::clearHighlights()
{
    struct{ void operator() (Highlight* hl) { delete hl; }} autodel;
    std::for_each(m_highlights.begin(), m_highlights.end(), autodel);
    m_highlights.clear();
}
