#include "stdafx.h"
#include "mudGameView.h"

bool MudGameView::onStart()
{
   if (!m_syscmds.init(this))
   {
       msgBox(m_hWnd, IDS_ERROR_SCRIPTENGINE_FAILED, MB_OK|MB_ICONSTOP);
       return false;
   }

   if (!m_manager.init())
   {
       msgBox(m_hWnd, IDS_ERROR_INITPROFILES_FAILED, MB_OK|MB_ICONSTOP);
       return false;
   }

   if (!m_manager.loadProfile())
   {
       if (!m_manager.createNewProfile(L"player"))
       {
           msgBox(m_hWnd, IDS_ERROR_NEWPROFILE_FAILED, MB_OK|MB_ICONSTOP);
           return false;
       }
   }

   updateProps();
   return true;
}

void MudGameView::onClose()
{
    m_manager.saveProfile();
}

void MudGameView::onNewProfile()
{
    NewProfileDlg dlg;
    dlg.loadProfiles(m_manager.getProfileGroup());    
    if (dlg.DoModal() == IDOK)
    {
        tstring source, name;        
        dlg.getProfiles(&source, &name);
        if (source.empty())
        {
            if (!m_manager.createNewProfile(name))
                msgBox(m_hWnd, IDS_ERROR_NEWPROFILE_FAILED, MB_OK|MB_ICONSTOP);
        }
        else
        {
            if (!m_manager.createCopyProfile(source, name))
                msgBox(m_hWnd, IDS_ERROR_NEWPROFILE_FAILED, MB_OK|MB_ICONSTOP);
        }
        updateProps();
    }
}

void MudGameView::onLoadProfile()
{
    LoadProfileDlg dlg;
    if (dlg.DoModal() == IDOK)
    {
        tstring group, name;        
        dlg.getProfiles(&group, &name);
        if (name.empty())
        {
            if (!m_manager.createNewProfile(group, L"player"))
                msgBox(m_hWnd, IDS_ERROR_NEWPROFILE_FAILED, MB_OK|MB_ICONSTOP);
            else
                updateProps();
            return;
        }

        if (m_manager.getProfileGroup() == group && m_manager.getProfileName() == name)
            return;

        if (!m_manager.saveProfile())
        {
            msgBox(m_hWnd, IDS_ERROR_CURRENTSAVEPROFILE_FAILED, MB_OK|MB_ICONSTOP);
            return;
        }

        if (!m_manager.loadNewProfile(group, name))
            msgBox(m_hWnd, IDS_ERROR_NEWPROFILE_FAILED, MB_OK|MB_ICONSTOP);

        updateProps();
    }
}
