#pragma once

#include "mudViewString.h"
#include "mudViewParser.h"
#include "propertiesPages/propertiesElements.h"
#include "common/atldock.h"

class MudView : public CWindowImpl<MudView>
{
    PropertiesElements *propElements;
    int m_lines_count;
    int m_last_visible_line;
    std::vector<MudViewString*> m_strings;
    bool m_last_string_updated;

public:
	DECLARE_WND_CLASS_EX(NULL, CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS, COLOR_BACKGROUND+1)
    MudView(PropertiesElements *elements);
    ~MudView();
    void accLastString(parseData *parse_data);
    void addText(parseData* parse_data);    
    void updateProps();

private:
	BEGIN_MSG_MAP(MudView)
        MESSAGE_HANDLER(WM_CREATE, OnCreate)
        MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
        MESSAGE_HANDLER(WM_SIZE, OnSize)
        MESSAGE_HANDLER(WM_VSCROLL, OnScroll)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
        MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBkgnd)
        MESSAGE_HANDLER(WM_MOUSEWHEEL, OnMouseWheel)
    END_MSG_MAP()

    LRESULT OnCreate(UINT, WPARAM, LPARAM, BOOL&) { return 0; }
    LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&) { m_hWnd = NULL; return 0; }
	LRESULT OnPaint(UINT, WPARAM, LPARAM, BOOL&) { renderView(); return 0;}
    LRESULT OnEraseBkgnd(UINT, WPARAM, LPARAM, BOOL&){ return 1; }
    LRESULT OnSize(UINT, WPARAM, LPARAM, BOOL&){ initRenerParams(); updateScrollbar(m_last_visible_line); return 0; }
    LRESULT OnScroll(UINT, WPARAM wparam, LPARAM, BOOL&){ setScrollbar(wparam); return 0; }    
    LRESULT OnMouseWheel(UINT, WPARAM wparam, LPARAM, BOOL&) { mouseWheel(HIWORD(wparam)); return 0; }    

private:
    void calcStringSizes(MudViewString *string);
    void renderView();
    void renderString(CDC* dc, MudViewString *s, int left_x, int bottom_y);
    void initRenerParams();
    void updateScrollbar(int new_visible_line);
    void setScrollbar(DWORD position);
    void mouseWheel(WORD position);
    void checkLimit(parseData* parse_data);    
};
